
int pCount;
int forceCount = 0;

//Forces
StructuredBuffer<float3> forceMultiplyXYZ;
//float4x4 XYZtoUVtransform;
StructuredBuffer<float4x4> XYZtoUVtransform;

float colorAdapt = 0;


//Texture source
Texture2D tex <string uiname="Texture";>;

SamplerState mySampler : IMMUTABLE
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
};

struct particle
{
	float3 pos;
	float3 vel;
	float4 col;
	float scale;
	float2 lifeFromTo;
	int index;
//	float3 rotation;
};
RWStructuredBuffer<particle> Output : BACKBUFFER;

//==============================================================================
//COMPUTE SHADER ===============================================================
//==============================================================================

[numthreads(64, 1, 1)]
void CSConstantForce( uint3 DTid : SV_DispatchThreadID )
{
	
	float3 p = Output[DTid.x].pos;
	float3 v = Output[DTid.x].vel;
	
	for (int i=0; i<forceCount; i++) {
	
		float3 samplePos = mul(float4(p,1), XYZtoUVtransform[0]).xyz;
		
		// Add force from texture
		float4 textureColor = tex.SampleLevel(mySampler,samplePos.xy,0);
		v += forceMultiplyXYZ[0] * (textureColor.xyz-0.5);
		
		Output[DTid.x].col = lerp(Output[DTid.x].col, textureColor, colorAdapt);
	}
	

	Output[DTid.x].vel = v;
	
}

//==============================================================================
//TECHNIQUES ===================================================================
//==============================================================================

technique11 whirlwind
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CSConstantForce() ) );
	}
}
